@echo off

rem	Establish environment variables for BCPL scripts

set vn=1
set rvn=02
set edt=20-Oct-2015

rem	Vn 1.01	20-Oct-2015	MCPLhdrs added
rem	Vn 1.01	15-Sep-2014	Execute from source directory
rem	Vn 1.00	20-Aug-2014	Initial version

if '%1'=='-l' goto help
if '%1'=='/?' goto help
if '%1'=='-h' (
  :help
  if defined BCPLenv (
    goto envset
  ) else (
    echo.
	echo 	BCPL environment has not been established
	echo.
	goto eof
  )
)

rem Initialize/purge BCPL environment

set BCPLenv=
set BCPLroot=
set GnuWin=
set minGWVn=

if '%1'=='-d' (
  echo 	BCPL environment cleared...
  goto eof
)

rem	Operating System			Version Number	Other Information
rem	Windows 1.0				1.04
rem	Windows 2.0				2.11
rem	Windows 3.0				3
rem	Windows NT 3.1				3.10.528
rem	Windows for Workgroups 3.11		3.11
rem	Windows NT Workstation 3.5		3.5.807
rem	Windows NT Workstation 3.51		3.51.1057
rem	Windows 95				4.0.950
rem	Windows NT Workstation 4.0		4.0.1381
rem	Windows 98				4.1.1998
rem	Windows 98 Second Edition		4.1.2222
rem	Windows Me				4.90.3000
rem	Windows 2000 Professional		5.0.2195
rem	Windows XP				5.1.2600	Current SP3
rem	Windows XP Professional x64 Edition	5.2.3790
rem	Windows Vista				6.0.6000	Current Version changed to 6.0.6002 with SP2
rem	Windows 7				6.1.7600	RTM
rem	Windows 8				6.2.(????)
rem	Windows Server 2012 R2			6.3.(????)
rem	Windows 8.1				6.3.(????)

rem	Check Windows Version...

for /f "usebackq tokens=*" %%i in (`ver`) do set w_vn=%%i
echo %w_vn% | findstr "5\.1\." > nul
if %errorlevel% equ 0 set m_vn=XP
echo %w_vn% | findstr "6\.1\." > nul
if %errorlevel% equ 0 set m_vn=W7

if not defined m_vn (
  echo.
  echo 	This version of %w_vn% isn't supported!
  echo.
  goto eof
)

set BCPLenv=Vn %vn%.%rvn%	%edt%

rem	Go to the directory hosting this script...
pushd "%~dp0"
rem	Find the directory name we're executing from:
for %%* in (.) do set BCPLdir=%%~nx*
if not %BCPLdir%==BCPL-0.9.8 (
  echo.
  echo 	Please:	a] 'cd' to the BCPLkit-0.9.8 directory and
  echo 		b] run %0 there
  echo.
  goto eof
)

for /f "usebackq tokens=*" %%i in (`cd`) do set pwd=%%i

rem	go to parent directory...
cd ..
if exist BCPLkit (
  for /f "usebackq tokens=*" %%i in (`cd`) do set BCPLroot=%%i\BCPLkit
)


rem		The following 'set' commands specify the homes of...
rem			a)	GnuWin:   your minGW (GNU for Windows) c compiler/assembler/loader installation
rem			b)	minGWVn:  your MinGW installation version number

rem	parse the path, looking for the CodeBlocks installation:

rem	for /f "usebackq tokens=*" %%i in (`echo %path:;= ^& echo.%`) do (
rem	  echo %%i | findstr "CodeBlocks" > nul
rem	  if %errorlevel% equ 0 set cbp=%%i
rem	)
rem	if defined cbp (
rem	  for /f "usebackq tokens=*" %%i in (`cd %cbp%\..`) do set GnuWin=%%i
rem	  cd %pwd%
rem	) else (
rem	  echo.
rem	  echo 	CodeBlocks MinGW not found - aborting...
rem	  echo.
rem	  goto eof
rem	)
	
if %m_vn%==XP (
  if exist "c:\program files\codeblocks\mingw" set GnuWin=C:\Program Files\CodeBlocks\MinGW
)
if %m_vn%==W7 (
  if exist "c:\program files (x86)\codeblocks\mingw" set GnuWin=C:\Program Files ^(x86^)\CodeBlocks\MinGW
)

if not defined GnuWin (
  echo.
  echo 	CodeBlocks MinGW not found - aborting...
  echo.
  goto eof
)

pushd
  for /f "usebackq tokens=*" %%i in (`cd`) do if exist BCPL-0.9.8 set BCPLocd=%%i\BCPL-0.9.8
popd


for /f "usebackq tokens=1,2,3" %%i in (`gcc --version`) do if '%%i'=='gcc' set minGWVn=%%k

:envset
echo.
echo 	BCPL environment established as:
echo.
set BCPL
set GnuWin
set minGWVn
echo.

:eof
popd
