// obcpl LIBHDR

GLOBAL $(
START: 1                // START(ARG)
ABORT: 3				// ABORT(N) - Calls BACKTRACE and MAPSTORE
BACKTRACE: 4
STACKTRACE: 4			// STACKTRACE() - Summarise the run-time stack
TRAP: 5                 // TRAP(N) - Run diagnostics on call of first N undefined GLOBALs

SELECTINPUT: 11         // SELECTINPUT(N)
SELECTOUTPUT: 12        // SELECTOUTPUT(N)
RDCH: 13                // CH := RDCH()
WRCH: 14                // WRCH(CH)
UNRDCH: 15              // UNRDCH()
INPUT: 16               // STREAM := INPUT()
OUTPUT: 17              // STREAM := OUTPUT()

TIMEOFDAY: 27			// S := TIMEOFDAY()
TIME: 28				// T := TIME()
DATE: 29				// S := DATE()
STOP: 30                // STOP(N)
LEVEL: 31               // P := LEVEL()
LONGJUMP: 32            // LONGJUMP(P,L)
REWIND: 35              // REWIND()

APTOVEC: 40             // RES := APTOVEC(F, N)
FINDOUTPUT: 41          // STREAM := FINDOUTPUT(S)
FINDINPUT: 42           // STREAM := FINDINPUT(S)
FINDAPPEND: 43			// STREAM := FINDAPPEND(S)
ENDSTREAM: 45           // ENDSTREAM(STREAM)
ENDREAD: 46             // ENDREAD()
ENDWRITE: 47            // ENDWRITE()
FILETABLE: 48			// Base of FILETABLE - for diagnostics: 24-Oct-2012
RENAME: 49				// R := RENAME(S1, S2)
DELETE: 50				// R := DELETE(S)
ENDTOINPUT: 51			// ENDTOINPUT()
GETENV: 52				// S := GETENV(ENVVAR)
PATHFINDINPUT: 53		// STREAM := PATHFINDINPUT(S)
FINDFILE: 54			// STREAM := FINDFILE(S, MODE)

WRITES: 60              // WRITES(S)
WRITEN: 62              // WRITEN(N)
NEWLINE: 63             // NEWLINE()
NEWPAGE: 64             // NEWPAGE()
PACKSTRING: 66          // I := PACKSTRING(U, S)
UNPACKSTRING: 67        // UNPACKSTRING(S, U)
WRITED: 68              // WRITED(N,W)
READN: 70               // N := READN()
TERMINATOR: 71          // Last byte read by READN()

CAPITALCH: 74			// CAPITALCH(CH)
WRITEHEX: 75            // WRITEHEX(N,D)
WRITEF: 76              // WRITEF(F,A1,A2,...,A11)
WRITEOCT: 77            // WRITEOCT(N,D)
MAPSTORE: 78			// MAPSTORE()

GETBYTE: 85             // CH := GETBYTE(V, N)
PUTBYTE: 86             // PUTBYTE(V, N, B)
GETVEC: 87              // V := GETVEC(SIZE)
FREEVEC: 88             // FREEVEC(V)

RDARGS: 90				// RDARGS(ignored, V, N)
RESULT2: 91             // Various results
STRCAT: 92           	// S := STRCAT(DEST, SRCE)
STR2NO: 93				// STR2NO(S)
STR2NUMB: 94			// STR2NUMB(S, N)
STACKBASE: 95           // Base of runtime stack
STACKEND: 96            // End of runtime stack
ARGC: 97                // UNIX argc
ARGV: 98                // UNIX argv as BCPL strings
PARAM: 99               // ARGV!1 or ""
$)

MANIFEST $(
SYSIN		= 0
SYSOUT		= 1
SYSERR		= 2			// Standard input, output and error streams (preopened, set to console)

ENDSTREAMCH	= -1
BYTESPERWORD = 4
BITSPERWORD = 32
MAXINT = #X7FFFFFFF
MININT = #X80000000
MAXSTRLENGTH = 255
FIRSTFREEGLOBAL = 100
UG = FIRSTFREEGLOBAL
$)
